import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:flutter/cupertino.dart';
import 'dart:async';

void main() {
  runApp(MyApp());
}

class MyApp extends StatelessWidget {
  // This widget is the root of your application.
  @override
  Widget build(BuildContext context) {
    String title = '';
    return MaterialApp(
      title: 'Flutter Demo',
      theme: ThemeData(
        primarySwatch: Colors.purple,
      ),
      home: new MyHomePage(title),
    );
  }
}

class MyHomePage extends StatefulWidget {
  final String title;
  MyHomePage(this.title);
  @override
  _MyHomePageState createState() => new _MyHomePageState();
}

class _MyHomePageState extends State<MyHomePage> {
  int _counter = 0;
  static const platformMethodChannel = const MethodChannel('com.sicilyliu');
  num nativeMessage = 0;
  String nativeMess = "";

  void _incrementCounter() {
    setState(() {
      _counter++;
    });
  }

  Future<dynamic> getData(String method, {Map arguments}) async {
    num _message;
    if (arguments == null) {
      return await platformMethodChannel.invokeMethod(method);
    } else {
      return await platformMethodChannel.invokeMethod(method, arguments);
    }
  }

  Future<dynamic> nativeMessageListener() async {
    platformMethodChannel.setMethodCallHandler((resultCall) {
      MethodCall call = resultCall;
      String method = call.method;
      Map arguments = call.arguments;
      int code = arguments["code"];
      String message = arguments["message"];
      setState(() {
        nativeMess +=
            " code $code message $message and method call $method calling";
      });
    });
  }

  @override
  void initState() {
    nativeMessageListener();
  }

  @override
  Widget build(BuildContext context) {
    return new Scaffold(
      appBar: new AppBar(
        title: new Text(widget.title),
      ),
      body: new Column(
        mainAxisAlignment: MainAxisAlignment.center,
        children: <Widget>[
          new Text(
            'counter = $_counter',
          ),
          new Text(
            '$nativeMessage',
            style: Theme.of(context).textTheme.display1,
          ),
          new Text(
            '$nativeMess',
          ),
          Padding(
            padding: EdgeInsets.all(30),
            child: FlatButton(
                onPressed: () {
                  getData('battery')
                  ..then((value) {
                    setState(() {
                      nativeMessage = value;
                    });
                  });
                },
                child: new Text(
                  'battery level',
                  style: TextStyle(
                    color: Colors.orange,
                    fontSize: 20,
                  ),
                )),
          ),
          Padding(
            padding: EdgeInsets.all(30),
            child: FlatButton(
                onPressed: () {
                  getData("hello")
                    ..then((dynamic value) {
                      int code = value["code"];
                      String message = value["message"];
                      setState(() {
                        nativeMessage = code;
                        nativeMess += message;
                      });
                    });
                },
                child: new Text(
                  'hello',
                  style: TextStyle(
                    color: Colors.green,
                    fontSize: 20,
                  ),
                )),
          ),
        ],
      ),
      floatingActionButton: new FloatingActionButton(
        onPressed: () => getData('getTime'),
        tooltip: 'increment',
        child: new Icon(Icons.adb),
      ),
    );
  }
}
